Index: palm/trunk/SOURCE/temperton_fft_mod.f90
===================================================================
--- palm/trunk/SOURCE/temperton_fft_mod.f90	(revision 3724)
+++ palm/trunk/SOURCE/temperton_fft_mod.f90	(revision 3725)
@@ -461,779 +465,819 @@
     INTEGER(iwp) ::  m     !< 
 
-    !  Intrinsic functions 
-!    INTRINSIC REAL, SQRT
-
-    !  Data statements 
-    DATA sin36/0.587785252292473_wp/, sin72/0.951056516295154_wp/, &
-         &      qrt5/0.559016994374947_wp/, sin60/0.866025403784437_wp/
-
-
-    !  Executable statements 
-
-    m = n/ifac
-    iink = la*inc1
-    jink = la*inc2
-    ijump = (ifac-1)*iink
-    kstop = (n-ifac)/(2*ifac)
-
-    ibad = 1
-    IF (lot>nfft) GO TO 180
+
+    DATA  sin36/0.587785252292473_wp/, sin72/0.951056516295154_wp/,                                &
+          qrt5/0.559016994374947_wp/,  sin60/0.866025403784437_wp/
+
+
+    ierr = 0
+
+    IF ( lot > nfft )  THEN
+       ierr = 1
+       RETURN
+    ENDIF
+
+    m = n / ifac
+    iink  = la * inc1
+    jink  = la * inc2
+    ijump = (ifac-1) * iink
+    kstop = ( n-ifac ) / ( 2*ifac )
+
     ibase = 0
     jbase = 0
     igo = ifac - 1
-    IF (igo==7) igo = 6
-    ibad = 2
-    IF (igo<1 .OR. igo>6) GO TO 180
-    GO TO (10,40,70,100,130,160) igo
-
-    ! Coding for factor 2
-
-10  CONTINUE
-    ia = 1
-    ib = ia + iink
-    ja = 1
-    jb = ja + (2*m-la)*inc2
-
-    IF (la==m) GO TO 30
-
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = a(ia+i) + a(ib+i)
-          c(jb+j) = a(ia+i) - a(ib+i)
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    ja = ja + jink
-    jink = 2*jink
-    jb = jb - jink
-    ibase = ibase + ijump
-    ijump = 2*ijump + iink
-    IF (ja==jb) GO TO 20
-    DO k = la, kstop, la
-       kb = k + k
-       c1 = trigs(kb+1)
-       s1 = trigs(kb+2)
-       jbase = 0
-       DO l = 1, la
-          i = ibase
-          j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-          DO ijk = 1, lot
-             c(ja+j) = a(ia+i) + (c1*a(ib+i)+s1*b(ib+i))
-             c(jb+j) = a(ia+i) - (c1*a(ib+i)+s1*b(ib+i))
-             d(ja+j) = (c1*b(ib+i)-s1*a(ib+i)) + b(ia+i)
-             d(jb+j) = (c1*b(ib+i)-s1*a(ib+i)) - b(ia+i)
-             i = i + inc3
-             j = j + inc4
-          END DO
-          ibase = ibase + inc1
-          jbase = jbase + inc2
-       END DO
-       ibase = ibase + ijump
-       ja = ja + jink
-       jb = jb - jink
-    END DO
-    IF (ja>jb) GO TO 170
-20  CONTINUE
-    jbase = 0
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = a(ia+i)
-          d(ja+j) = -a(ib+i)
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-
-    GO TO 170
-30  CONTINUE
-    z = 1.0_wp/REAL(n,KIND=wp)
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = z*(a(ia+i)+a(ib+i))
-          c(jb+j) = z*(a(ia+i)-a(ib+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    GO TO 170
-
-    ! Coding for factor 3
-
-40  CONTINUE
-    ia = 1
-    ib = ia + iink
-    ic = ib + iink
-    ja = 1
-    jb = ja + (2*m-la)*inc2
-    jc = jb
-
-    IF (la==m) GO TO 60
-
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = a(ia+i) + (a(ib+i)+a(ic+i))
-          c(jb+j) = a(ia+i) - 0.5_wp*(a(ib+i)+a(ic+i))
-          d(jb+j) = sin60*(a(ic+i)-a(ib+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    ja = ja + jink
-    jink = 2*jink
-    jb = jb + jink
-    jc = jc - jink
-    ibase = ibase + ijump
-    ijump = 2*ijump + iink
-    IF (ja==jc) GO TO 50
-    DO k = la, kstop, la
-       kb = k + k
-       kc = kb + kb
-       c1 = trigs(kb+1)
-       s1 = trigs(kb+2)
-       c2 = trigs(kc+1)
-       s2 = trigs(kc+2)
-       jbase = 0
-       DO l = 1, la
-          i = ibase
-          j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-          DO ijk = 1, lot
-             a1 = (c1*a(ib+i)+s1*b(ib+i)) + (c2*a(ic+i)+s2*b(ic+i))
-             b1 = (c1*b(ib+i)-s1*a(ib+i)) + (c2*b(ic+i)-s2*a(ic+i))
-             a2 = a(ia+i) - 0.5_wp*a1
-             b2 = b(ia+i) - 0.5_wp*b1
-             a3 = sin60*((c1*a(ib+i)+s1*b(ib+i))-(c2*a(ic+i)+s2*b(ic+i)))
-             b3 = sin60*((c1*b(ib+i)-s1*a(ib+i))-(c2*b(ic+i)-s2*a(ic+i)))
-             c(ja+j) = a(ia+i) + a1
-             d(ja+j) = b(ia+i) + b1
-             c(jb+j) = a2 + b3
-             d(jb+j) = b2 - a3
-             c(jc+j) = a2 - b3
-             d(jc+j) = -(b2+a3)
-             i = i + inc3
-             j = j + inc4
-          END DO
-          ibase = ibase + inc1
-          jbase = jbase + inc2
-       END DO
-       ibase = ibase + ijump
-       ja = ja + jink
-       jb = jb + jink
-       jc = jc - jink
-    END DO
-    IF (ja>jc) GO TO 170
-50  CONTINUE
-    jbase = 0
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = a(ia+i) + 0.5_wp*(a(ib+i)-a(ic+i))
-          d(ja+j) = -sin60*(a(ib+i)+a(ic+i))
-          c(jb+j) = a(ia+i) - (a(ib+i)-a(ic+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-
-    GO TO 170
-60  CONTINUE
-    z = 1.0_wp/REAL(n,KIND=wp)
-    zsin60 = z*sin60
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = z*(a(ia+i)+(a(ib+i)+a(ic+i)))
-          c(jb+j) = z*(a(ia+i)-0.5_wp*(a(ib+i)+a(ic+i)))
-          d(jb+j) = zsin60*(a(ic+i)-a(ib+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    GO TO 170
-
-    ! Coding for factor 4
-
-70  CONTINUE
-    ia = 1
-    ib = ia + iink
-    ic = ib + iink
-    id = ic + iink
-    ja = 1
-    jb = ja + (2*m-la)*inc2
-    jc = jb + 2*m*inc2
-    jd = jb
-
-    IF (la==m) GO TO 90
-
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = (a(ia+i)+a(ic+i)) + (a(ib+i)+a(id+i))
-          c(jc+j) = (a(ia+i)+a(ic+i)) - (a(ib+i)+a(id+i))
-          c(jb+j) = a(ia+i) - a(ic+i)
-          d(jb+j) = a(id+i) - a(ib+i)
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    ja = ja + jink
-    jink = 2*jink
-    jb = jb + jink
-    jc = jc - jink
-    jd = jd - jink
-    ibase = ibase + ijump
-    ijump = 2*ijump + iink
-    IF (jb==jc) GO TO 80
-    DO k = la, kstop, la
-       kb = k + k
-       kc = kb + kb
-       kd = kc + kb
-       c1 = trigs(kb+1)
-       s1 = trigs(kb+2)
-       c2 = trigs(kc+1)
-       s2 = trigs(kc+2)
-       c3 = trigs(kd+1)
-       s3 = trigs(kd+2)
-       jbase = 0
-       DO l = 1, la
-          i = ibase
-          j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-          DO ijk = 1, lot
-             a0 = a(ia+i) + (c2*a(ic+i)+s2*b(ic+i))
-             a2 = a(ia+i) - (c2*a(ic+i)+s2*b(ic+i))
-             a1 = (c1*a(ib+i)+s1*b(ib+i)) + (c3*a(id+i)+s3*b(id+i))
-             a3 = (c1*a(ib+i)+s1*b(ib+i)) - (c3*a(id+i)+s3*b(id+i))
-             b0 = b(ia+i) + (c2*b(ic+i)-s2*a(ic+i))
-             b2 = b(ia+i) - (c2*b(ic+i)-s2*a(ic+i))
-             b1 = (c1*b(ib+i)-s1*a(ib+i)) + (c3*b(id+i)-s3*a(id+i))
-             b3 = (c1*b(ib+i)-s1*a(ib+i)) - (c3*b(id+i)-s3*a(id+i))
-             c(ja+j) = a0 + a1
-             c(jc+j) = a0 - a1
-             d(ja+j) = b0 + b1
-             d(jc+j) = b1 - b0
-             c(jb+j) = a2 + b3
-             c(jd+j) = a2 - b3
-             d(jb+j) = b2 - a3
-             d(jd+j) = -(b2+a3)
-             i = i + inc3
-             j = j + inc4
-          END DO
-          ibase = ibase + inc1
-          jbase = jbase + inc2
-       END DO
-       ibase = ibase + ijump
-       ja = ja + jink
-       jb = jb + jink
-       jc = jc - jink
-       jd = jd - jink
-    END DO
-    IF (jb>jc) GO TO 170
-80  CONTINUE
-    sin45 = SQRT(0.5_wp)
-    jbase = 0
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = a(ia+i) + sin45*(a(ib+i)-a(id+i))
-          c(jb+j) = a(ia+i) - sin45*(a(ib+i)-a(id+i))
-          d(ja+j) = -a(ic+i) - sin45*(a(ib+i)+a(id+i))
-          d(jb+j) = a(ic+i) - sin45*(a(ib+i)+a(id+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-
-    GO TO 170
-90  CONTINUE
-    z = 1.0_wp/REAL(n,KIND=wp)
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = z*((a(ia+i)+a(ic+i))+(a(ib+i)+a(id+i)))
-          c(jc+j) = z*((a(ia+i)+a(ic+i))-(a(ib+i)+a(id+i)))
-          c(jb+j) = z*(a(ia+i)-a(ic+i))
-          d(jb+j) = z*(a(id+i)-a(ib+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    GO TO 170
-
-    ! Coding for factor 5
-
-100 CONTINUE
-    ia = 1
-    ib = ia + iink
-    ic = ib + iink
-    id = ic + iink
-    ie = id + iink
-    ja = 1
-    jb = ja + (2*m-la)*inc2
-    jc = jb + 2*m*inc2
-    jd = jc
-    je = jb
-
-    IF (la==m) GO TO 120
-
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          a1 = a(ib+i) + a(ie+i)
-          a3 = a(ib+i) - a(ie+i)
-          a2 = a(ic+i) + a(id+i)
-          a4 = a(ic+i) - a(id+i)
-          a5 = a(ia+i) - 0.25_wp*(a1+a2)
-          a6 = qrt5*(a1-a2)
-          c(ja+j) = a(ia+i) + (a1+a2)
-          c(jb+j) = a5 + a6
-          c(jc+j) = a5 - a6
-          d(jb+j) = -sin72*a3 - sin36*a4
-          d(jc+j) = -sin36*a3 + sin72*a4
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    ja = ja + jink
-    jink = 2*jink
-    jb = jb + jink
-    jc = jc + jink
-    jd = jd - jink
-    je = je - jink
-    ibase = ibase + ijump
-    ijump = 2*ijump + iink
-    IF (jb==jd) GO TO 110
-    DO k = la, kstop, la
-       kb = k + k
-       kc = kb + kb
-       kd = kc + kb
-       ke = kd + kb
-       c1 = trigs(kb+1)
-       s1 = trigs(kb+2)
-       c2 = trigs(kc+1)
-       s2 = trigs(kc+2)
-       c3 = trigs(kd+1)
-       s3 = trigs(kd+2)
-       c4 = trigs(ke+1)
-       s4 = trigs(ke+2)
-       jbase = 0
-       DO l = 1, la
-          i = ibase
-          j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-          DO ijk = 1, lot
-             a1 = (c1*a(ib+i)+s1*b(ib+i)) + (c4*a(ie+i)+s4*b(ie+i))
-             a3 = (c1*a(ib+i)+s1*b(ib+i)) - (c4*a(ie+i)+s4*b(ie+i))
-             a2 = (c2*a(ic+i)+s2*b(ic+i)) + (c3*a(id+i)+s3*b(id+i))
-             a4 = (c2*a(ic+i)+s2*b(ic+i)) - (c3*a(id+i)+s3*b(id+i))
-             b1 = (c1*b(ib+i)-s1*a(ib+i)) + (c4*b(ie+i)-s4*a(ie+i))
-             b3 = (c1*b(ib+i)-s1*a(ib+i)) - (c4*b(ie+i)-s4*a(ie+i))
-             b2 = (c2*b(ic+i)-s2*a(ic+i)) + (c3*b(id+i)-s3*a(id+i))
-             b4 = (c2*b(ic+i)-s2*a(ic+i)) - (c3*b(id+i)-s3*a(id+i))
-             a5 = a(ia+i) - 0.25_wp*(a1+a2)
-             a6 = qrt5*(a1-a2)
-             b5 = b(ia+i) - 0.25_wp*(b1+b2)
-             b6 = qrt5*(b1-b2)
-             a10 = a5 + a6
-             a20 = a5 - a6
-             b10 = b5 + b6
-             b20 = b5 - b6
-             a11 = sin72*b3 + sin36*b4
-             a21 = sin36*b3 - sin72*b4
-             b11 = sin72*a3 + sin36*a4
-             b21 = sin36*a3 - sin72*a4
-             c(ja+j) = a(ia+i) + (a1+a2)
-             c(jb+j) = a10 + a11
-             c(je+j) = a10 - a11
-             c(jc+j) = a20 + a21
-             c(jd+j) = a20 - a21
-             d(ja+j) = b(ia+i) + (b1+b2)
-             d(jb+j) = b10 - b11
-             d(je+j) = -(b10+b11)
-             d(jc+j) = b20 - b21
-             d(jd+j) = -(b20+b21)
-             i = i + inc3
-             j = j + inc4
-          END DO
-          ibase = ibase + inc1
-          jbase = jbase + inc2
-       END DO
-       ibase = ibase + ijump
-       ja = ja + jink
-       jb = jb + jink
-       jc = jc + jink
-       jd = jd - jink
-       je = je - jink
-    END DO
-    IF (jb>jd) GO TO 170
-110 CONTINUE
-    jbase = 0
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          a1 = a(ib+i) + a(ie+i)
-          a3 = a(ib+i) - a(ie+i)
-          a2 = a(ic+i) + a(id+i)
-          a4 = a(ic+i) - a(id+i)
-          a5 = a(ia+i) + 0.25_wp*(a3-a4)
-          a6 = qrt5*(a3+a4)
-          c(ja+j) = a5 + a6
-          c(jb+j) = a5 - a6
-          c(jc+j) = a(ia+i) - (a3-a4)
-          d(ja+j) = -sin36*a1 - sin72*a2
-          d(jb+j) = -sin72*a1 + sin36*a2
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-
-    GO TO 170
-120 CONTINUE
-    z = 1.0_wp/REAL(n,KIND=wp)
-    zqrt5 = z*qrt5
-    zsin36 = z*sin36
-    zsin72 = z*sin72
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          a1 = a(ib+i) + a(ie+i)
-          a3 = a(ib+i) - a(ie+i)
-          a2 = a(ic+i) + a(id+i)
-          a4 = a(ic+i) - a(id+i)
-          a5 = z*(a(ia+i)-0.25_wp*(a1+a2))
-          a6 = zqrt5*(a1-a2)
-          c(ja+j) = z*(a(ia+i)+(a1+a2))
-          c(jb+j) = a5 + a6
-          c(jc+j) = a5 - a6
-          d(jb+j) = -zsin72*a3 - zsin36*a4
-          d(jc+j) = -zsin36*a3 + zsin72*a4
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    GO TO 170
-
-    ! Coding for factor 6
-
-130 CONTINUE
-    ia = 1
-    ib = ia + iink
-    ic = ib + iink
-    id = ic + iink
-    ie = id + iink
-    if = ie + iink
-    ja = 1
-    jb = ja + (2*m-la)*inc2
-    jc = jb + 2*m*inc2
-    jd = jc + 2*m*inc2
-    je = jc
-    jf = jb
-
-    IF (la==m) GO TO 150
-
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          a11 = (a(ic+i)+a(if+i)) + (a(ib+i)+a(ie+i))
-          c(ja+j) = (a(ia+i)+a(id+i)) + a11
-          c(jc+j) = (a(ia+i)+a(id+i)-0.5_wp*a11)
-          d(jc+j) = sin60*((a(ic+i)+a(if+i))-(a(ib+i)+a(ie+i)))
-          a11 = (a(ic+i)-a(if+i)) + (a(ie+i)-a(ib+i))
-          c(jb+j) = (a(ia+i)-a(id+i)) - 0.5_wp*a11
-          d(jb+j) = sin60*((a(ie+i)-a(ib+i))-(a(ic+i)-a(if+i)))
-          c(jd+j) = (a(ia+i)-a(id+i)) + a11
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    ja = ja + jink
-    jink = 2*jink
-    jb = jb + jink
-    jc = jc + jink
-    jd = jd - jink
-    je = je - jink
-    jf = jf - jink
-    ibase = ibase + ijump
-    ijump = 2*ijump + iink
-    IF (jc==jd) GO TO 140
-    DO k = la, kstop, la
-       kb = k + k
-       kc = kb + kb
-       kd = kc + kb
-       ke = kd + kb
-       kf = ke + kb
-       c1 = trigs(kb+1)
-       s1 = trigs(kb+2)
-       c2 = trigs(kc+1)
-       s2 = trigs(kc+2)
-       c3 = trigs(kd+1)
-       s3 = trigs(kd+2)
-       c4 = trigs(ke+1)
-       s4 = trigs(ke+2)
-       c5 = trigs(kf+1)
-       s5 = trigs(kf+2)
-       jbase = 0
-       DO l = 1, la
-          i = ibase
-          j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-          DO ijk = 1, lot
-             a1 = c1*a(ib+i) + s1*b(ib+i)
-             b1 = c1*b(ib+i) - s1*a(ib+i)
-             a2 = c2*a(ic+i) + s2*b(ic+i)
-             b2 = c2*b(ic+i) - s2*a(ic+i)
-             a3 = c3*a(id+i) + s3*b(id+i)
-             b3 = c3*b(id+i) - s3*a(id+i)
-             a4 = c4*a(ie+i) + s4*b(ie+i)
-             b4 = c4*b(ie+i) - s4*a(ie+i)
-             a5 = c5*a(if+i) + s5*b(if+i)
-             b5 = c5*b(if+i) - s5*a(if+i)
-             a11 = (a2+a5) + (a1+a4)
-             a20 = (a(ia+i)+a3) - 0.5_wp*a11
-             a21 = sin60*((a2+a5)-(a1+a4))
-             b11 = (b2+b5) + (b1+b4)
-             b20 = (b(ia+i)+b3) - 0.5_wp*b11
-             b21 = sin60*((b2+b5)-(b1+b4))
-             c(ja+j) = (a(ia+i)+a3) + a11
-             d(ja+j) = (b(ia+i)+b3) + b11
-             c(jc+j) = a20 - b21
-             d(jc+j) = a21 + b20
-             c(je+j) = a20 + b21
-             d(je+j) = a21 - b20
-             a11 = (a2-a5) + (a4-a1)
-             a20 = (a(ia+i)-a3) - 0.5_wp*a11
-             a21 = sin60*((a4-a1)-(a2-a5))
-             b11 = (b5-b2) - (b4-b1)
-             b20 = (b3-b(ia+i)) - 0.5_wp*b11
-             b21 = sin60*((b5-b2)+(b4-b1))
-             c(jb+j) = a20 - b21
-             d(jb+j) = a21 - b20
-             c(jd+j) = a11 + (a(ia+i)-a3)
-             d(jd+j) = b11 + (b3-b(ia+i))
-             c(jf+j) = a20 + b21
-             d(jf+j) = a21 + b20
-             i = i + inc3
-             j = j + inc4
-          END DO
-          ibase = ibase + inc1
-          jbase = jbase + inc2
-       END DO
-       ibase = ibase + ijump
-       ja = ja + jink
-       jb = jb + jink
-       jc = jc + jink
-       jd = jd - jink
-       je = je - jink
-       jf = jf - jink
-    END DO
-    IF (jc>jd) GO TO 170
-140 CONTINUE
-    jbase = 0
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = (a(ia+i)+0.5_wp*(a(ic+i)-a(ie+i))) + sin60*(a(ib+i)-a(if+i))
-          d(ja+j) = -(a(id+i)+0.5_wp*(a(ib+i)+a(if+i))) - sin60*(a(ic+i)+a(ie+i))
-          c(jb+j) = a(ia+i) - (a(ic+i)-a(ie+i))
-          d(jb+j) = a(id+i) - (a(ib+i)+a(if+i))
-          c(jc+j) = (a(ia+i)+0.5_wp*(a(ic+i)-a(ie+i))) - sin60*(a(ib+i)-a(if+i))
-          d(jc+j) = -(a(id+i)+0.5_wp*(a(ib+i)+a(if+i))) + sin60*(a(ic+i)+a(ie+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-
-    GO TO 170
-150 CONTINUE
-    z = 1.0_wp/REAL(n,KIND=wp)
-    zsin60 = z*sin60
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          a11 = (a(ic+i)+a(if+i)) + (a(ib+i)+a(ie+i))
-          c(ja+j) = z*((a(ia+i)+a(id+i))+a11)
-          c(jc+j) = z*((a(ia+i)+a(id+i))-0.5_wp*a11)
-          d(jc+j) = zsin60*((a(ic+i)+a(if+i))-(a(ib+i)+a(ie+i)))
-          a11 = (a(ic+i)-a(if+i)) + (a(ie+i)-a(ib+i))
-          c(jb+j) = z*((a(ia+i)-a(id+i))-0.5_wp*a11)
-          d(jb+j) = zsin60*((a(ie+i)-a(ib+i))-(a(ic+i)-a(if+i)))
-          c(jd+j) = z*((a(ia+i)-a(id+i))+a11)
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-    GO TO 170
-
-    ! Coding for factor 8
-
-160 CONTINUE
-    ibad = 3
-    IF (la/=m) GO TO 180
-    ia = 1
-    ib = ia + iink
-    ic = ib + iink
-    id = ic + iink
-    ie = id + iink
-    if = ie + iink
-    ig = if + iink
-    ih = ig + iink
-    ja = 1
-    jb = ja + la*inc2
-    jc = jb + 2*m*inc2
-    jd = jc + 2*m*inc2
-    je = jd + 2*m*inc2
-    z = 1.0_wp/REAL(n,KIND=wp)
-    zsin45 = z*SQRT(0.5_wp)
-
-    DO l = 1, la
-       i = ibase
-       j = jbase
-!DIR$ IVDEP
-!CDIR NODEP
-!OCL NOVREC
-       DO ijk = 1, lot
-          c(ja+j) = z*(((a(ia+i)+a(ie+i))+(a(ic+i)+a(ig+i)))+((a(id+i)+ &
-               &          a(ih+i))+(a(ib+i)+a(if+i))))
-          c(je+j) = z*(((a(ia+i)+a(ie+i))+(a(ic+i)+a(ig+i)))-((a(id+i)+ &
-               &          a(ih+i))+(a(ib+i)+a(if+i))))
-          c(jc+j) = z*((a(ia+i)+a(ie+i))-(a(ic+i)+a(ig+i)))
-          d(jc+j) = z*((a(id+i)+a(ih+i))-(a(ib+i)+a(if+i)))
-          c(jb+j) = z*(a(ia+i)-a(ie+i)) + zsin45*((a(ih+i)-a(id+i))-(a(if+ &
-               &          i)-a(ib+i)))
-          c(jd+j) = z*(a(ia+i)-a(ie+i)) - zsin45*((a(ih+i)-a(id+i))-(a(if+ &
-               &          i)-a(ib+i)))
-          d(jb+j) = zsin45*((a(ih+i)-a(id+i))+(a(if+i)-a(ib+i))) + &
-               &          z*(a(ig+i)-a(ic+i))
-          d(jd+j) = zsin45*((a(ih+i)-a(id+i))+(a(if+i)-a(ib+i))) - &
-               &          z*(a(ig+i)-a(ic+i))
-          i = i + inc3
-          j = j + inc4
-       END DO
-       ibase = ibase + inc1
-       jbase = jbase + inc2
-    END DO
-
-    ! Return
-
-170 CONTINUE
-    ibad = 0
-180 CONTINUE
-    ierr = ibad
-    RETURN
-  END SUBROUTINE qpassm
+    IF ( igo == 7 )  igo = 6
+
+    IF (igo < 1 .OR. igo > 6 )  THEN
+       ierr = 2
+       RETURN
+    ENDIF
+
+
+    SELECT CASE ( igo )
+
+!
+!--    Coding for factor 2
+       CASE ( 1 )
+          ia = 1
+          ib = ia + iink
+          ja = 1
+          jb = ja + (2*m-la) * inc2
+
+          IF ( la /= m )  THEN
+
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = a(ia+i) + a(ib+i)
+                   c(jb+j) = a(ia+i) - a(ib+i)
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+             ja = ja + jink
+             jink = 2 * jink
+             jb = jb - jink
+             ibase = ibase + ijump
+             ijump = 2 * ijump + iink
+
+             IF ( ja /= jb )  THEN
+
+                DO  k = la, kstop, la
+                   kb = k + k
+                   c1 = trigs(kb+1)
+                   s1 = trigs(kb+2)
+                   jbase = 0
+                   DO  l = 1, la
+                      i = ibase
+                      j = jbase
+                      !DIR$ IVDEP
+                      !CDIR NODEP
+                      !OCL NOVREC
+                      DO  ijk = 1, lot
+                         c(ja+j) = a(ia+i) + (c1*a(ib+i)+s1*b(ib+i))
+                         c(jb+j) = a(ia+i) - (c1*a(ib+i)+s1*b(ib+i))
+                         d(ja+j) = (c1*b(ib+i)-s1*a(ib+i)) + b(ia+i)
+                         d(jb+j) = (c1*b(ib+i)-s1*a(ib+i)) - b(ia+i)
+                         i = i + inc3
+                         j = j + inc4
+                      ENDDO
+                      ibase = ibase + inc1
+                      jbase = jbase + inc2
+                   ENDDO
+
+                   ibase = ibase + ijump
+                   ja = ja + jink
+                   jb = jb - jink
+                ENDDO
+
+                IF ( ja > jb )  RETURN
+
+             ENDIF
+
+             jbase = 0
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = a(ia+i)
+                   d(ja+j) = -a(ib+i)
+                   i = i + inc3
+                   j = j + inc4
+
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ELSE
+
+             z = 1.0_wp/REAL(n,KIND=wp)
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = z*(a(ia+i)+a(ib+i))
+                   c(jb+j) = z*(a(ia+i)-a(ib+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ENDIF
+
+!
+!--    Coding for factor 3
+       CASE ( 2 )
+
+          ia = 1
+          ib = ia + iink
+          ic = ib + iink
+          ja = 1
+          jb = ja + (2*m-la) * inc2
+          jc = jb
+
+          IF ( la /= m )  THEN
+
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = a(ia+i) + (a(ib+i)+a(ic+i))
+                   c(jb+j) = a(ia+i) - 0.5_wp*(a(ib+i)+a(ic+i))
+                   d(jb+j) = sin60*(a(ic+i)-a(ib+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+             ja = ja + jink
+             jink = 2 * jink
+             jb = jb + jink
+             jc = jc - jink
+             ibase = ibase + ijump
+             ijump = 2 * ijump + iink
+
+             IF ( ja /= jc )  THEN
+
+                DO  k = la, kstop, la
+                   kb = k + k
+                   kc = kb + kb
+                   c1 = trigs(kb+1)
+                   s1 = trigs(kb+2)
+                   c2 = trigs(kc+1)
+                   s2 = trigs(kc+2)
+
+                   jbase = 0
+                   DO  l = 1, la
+                      i = ibase
+                      j = jbase
+                      !DIR$ IVDEP
+                      !CDIR NODEP
+                      !OCL NOVREC
+                      DO  ijk = 1, lot
+                         a1 = (c1*a(ib+i)+s1*b(ib+i)) + (c2*a(ic+i)+s2*b(ic+i))
+                         b1 = (c1*b(ib+i)-s1*a(ib+i)) + (c2*b(ic+i)-s2*a(ic+i))
+                         a2 = a(ia+i) - 0.5_wp*a1
+                         b2 = b(ia+i) - 0.5_wp*b1
+                         a3 = sin60*((c1*a(ib+i)+s1*b(ib+i))-(c2*a(ic+i)+s2*b(ic+i)))
+                         b3 = sin60*((c1*b(ib+i)-s1*a(ib+i))-(c2*b(ic+i)-s2*a(ic+i)))
+                         c(ja+j) = a(ia+i) + a1
+                         d(ja+j) = b(ia+i) + b1
+                         c(jb+j) = a2 + b3
+                         d(jb+j) = b2 - a3
+                         c(jc+j) = a2 - b3
+                         d(jc+j) = -(b2+a3)
+                         i = i + inc3
+                         j = j + inc4
+                      ENDDO
+                      ibase = ibase + inc1
+                      jbase = jbase + inc2
+                   ENDDO
+                   ibase = ibase + ijump
+                   ja = ja + jink
+                   jb = jb + jink
+                   jc = jc - jink
+                ENDDO
+
+                IF ( ja > jc )  RETURN
+
+             ENDIF
+
+             jbase = 0
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = a(ia+i) + 0.5_wp*(a(ib+i)-a(ic+i))
+                   d(ja+j) = -sin60*(a(ib+i)+a(ic+i))
+                   c(jb+j) = a(ia+i) - (a(ib+i)-a(ic+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ELSE
+
+             z = 1.0_wp / REAL( n, KIND=wp )
+             zsin60 = z*sin60
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = z*(a(ia+i)+(a(ib+i)+a(ic+i)))
+                   c(jb+j) = z*(a(ia+i)-0.5_wp*(a(ib+i)+a(ic+i)))
+                   d(jb+j) = zsin60*(a(ic+i)-a(ib+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ENDIF
+
+!
+!--    Coding for factor 4
+       CASE ( 3 )
+
+          ia = 1
+          ib = ia + iink
+          ic = ib + iink
+          id = ic + iink
+          ja = 1
+          jb = ja + (2*m-la) * inc2
+          jc = jb + 2*m*inc2
+          jd = jb
+
+          IF ( la /= m )  THEN
+
+             DO  l = 1, la
+
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = (a(ia+i)+a(ic+i)) + (a(ib+i)+a(id+i))
+                   c(jc+j) = (a(ia+i)+a(ic+i)) - (a(ib+i)+a(id+i))
+                   c(jb+j) = a(ia+i) - a(ic+i)
+                   d(jb+j) = a(id+i) - a(ib+i)
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+             ja = ja + jink
+             jink = 2 * jink
+             jb = jb + jink
+             jc = jc - jink
+             jd = jd - jink
+             ibase = ibase + ijump
+             ijump = 2 * ijump + iink
+
+             IF ( jb /= jc )  THEN
+
+                DO  k = la, kstop, la
+                   kb = k + k
+                   kc = kb + kb
+                   kd = kc + kb
+                   c1 = trigs(kb+1)
+                   s1 = trigs(kb+2)
+                   c2 = trigs(kc+1)
+                   s2 = trigs(kc+2)
+                   c3 = trigs(kd+1)
+                   s3 = trigs(kd+2)
+                   jbase = 0
+                   DO  l = 1, la
+                      i = ibase
+                      j = jbase
+                      !DIR$ IVDEP
+                      !CDIR NODEP
+                      !OCL NOVREC
+                      DO  ijk = 1, lot
+                         a0 = a(ia+i) + (c2*a(ic+i)+s2*b(ic+i))
+                         a2 = a(ia+i) - (c2*a(ic+i)+s2*b(ic+i))
+                         a1 = (c1*a(ib+i)+s1*b(ib+i)) + (c3*a(id+i)+s3*b(id+i))
+                         a3 = (c1*a(ib+i)+s1*b(ib+i)) - (c3*a(id+i)+s3*b(id+i))
+                         b0 = b(ia+i) + (c2*b(ic+i)-s2*a(ic+i))
+                         b2 = b(ia+i) - (c2*b(ic+i)-s2*a(ic+i))
+                         b1 = (c1*b(ib+i)-s1*a(ib+i)) + (c3*b(id+i)-s3*a(id+i))
+                         b3 = (c1*b(ib+i)-s1*a(ib+i)) - (c3*b(id+i)-s3*a(id+i))
+                         c(ja+j) = a0 + a1
+                         c(jc+j) = a0 - a1
+                         d(ja+j) = b0 + b1
+                         d(jc+j) = b1 - b0
+                         c(jb+j) = a2 + b3
+                         c(jd+j) = a2 - b3
+                         d(jb+j) = b2 - a3
+                         d(jd+j) = -(b2+a3)
+                         i = i + inc3
+                         j = j + inc4
+                      ENDDO
+                      ibase = ibase + inc1
+                      jbase = jbase + inc2
+                   ENDDO
+                   ibase = ibase + ijump
+                   ja = ja + jink
+                   jb = jb + jink
+                   jc = jc - jink
+                   jd = jd - jink
+                ENDDO
+
+                IF ( jb > jc )  RETURN
+
+             ENDIF
+
+             sin45 = SQRT( 0.5_wp )
+             jbase = 0
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = a(ia+i) + sin45*(a(ib+i)-a(id+i))
+                   c(jb+j) = a(ia+i) - sin45*(a(ib+i)-a(id+i))
+                   d(ja+j) = -a(ic+i) - sin45*(a(ib+i)+a(id+i))
+                   d(jb+j) = a(ic+i) - sin45*(a(ib+i)+a(id+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ELSE
+
+             z = 1.0_wp / REAL( n, KIND=wp )
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = z*((a(ia+i)+a(ic+i))+(a(ib+i)+a(id+i)))
+                   c(jc+j) = z*((a(ia+i)+a(ic+i))-(a(ib+i)+a(id+i)))
+                   c(jb+j) = z*(a(ia+i)-a(ic+i))
+                   d(jb+j) = z*(a(id+i)-a(ib+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ENDIF
+
+!
+!--    Coding for factor 5
+       CASE ( 4 )
+
+          ia = 1
+          ib = ia + iink
+          ic = ib + iink
+          id = ic + iink
+          ie = id + iink
+          ja = 1
+          jb = ja + (2*m-la) * inc2
+          jc = jb + 2*m*inc2
+          jd = jc
+          je = jb
+
+          IF ( la /= m )  THEN
+
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   a1 = a(ib+i) + a(ie+i)
+                   a3 = a(ib+i) - a(ie+i)
+                   a2 = a(ic+i) + a(id+i)
+                   a4 = a(ic+i) - a(id+i)
+                   a5 = a(ia+i) - 0.25_wp*(a1+a2)
+                   a6 = qrt5*(a1-a2)
+                   c(ja+j) = a(ia+i) + (a1+a2)
+                   c(jb+j) = a5 + a6
+                   c(jc+j) = a5 - a6
+                   d(jb+j) = -sin72*a3 - sin36*a4
+                   d(jc+j) = -sin36*a3 + sin72*a4
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+             ja = ja + jink
+             jink = 2 * jink
+             jb = jb + jink
+             jc = jc + jink
+             jd = jd - jink
+             je = je - jink
+             ibase = ibase + ijump
+             ijump = 2 * ijump + iink
+
+             IF ( jb /= jd )  THEN
+
+                DO  k = la, kstop, la
+                   kb = k + k
+                   kc = kb + kb
+                   kd = kc + kb
+                   ke = kd + kb
+                   c1 = trigs(kb+1)
+                   s1 = trigs(kb+2)
+                   c2 = trigs(kc+1)
+                   s2 = trigs(kc+2)
+                   c3 = trigs(kd+1)
+                   s3 = trigs(kd+2)
+                   c4 = trigs(ke+1)
+                   s4 = trigs(ke+2)
+                   jbase = 0
+                   DO  l = 1, la
+                      i = ibase
+                      j = jbase
+                      !DIR$ IVDEP
+                      !CDIR NODEP
+                      !OCL NOVREC
+                      DO  ijk = 1, lot
+                         a1 = (c1*a(ib+i)+s1*b(ib+i)) + (c4*a(ie+i)+s4*b(ie+i))
+                         a3 = (c1*a(ib+i)+s1*b(ib+i)) - (c4*a(ie+i)+s4*b(ie+i))
+                         a2 = (c2*a(ic+i)+s2*b(ic+i)) + (c3*a(id+i)+s3*b(id+i))
+                         a4 = (c2*a(ic+i)+s2*b(ic+i)) - (c3*a(id+i)+s3*b(id+i))
+                         b1 = (c1*b(ib+i)-s1*a(ib+i)) + (c4*b(ie+i)-s4*a(ie+i))
+                         b3 = (c1*b(ib+i)-s1*a(ib+i)) - (c4*b(ie+i)-s4*a(ie+i))
+                         b2 = (c2*b(ic+i)-s2*a(ic+i)) + (c3*b(id+i)-s3*a(id+i))
+                         b4 = (c2*b(ic+i)-s2*a(ic+i)) - (c3*b(id+i)-s3*a(id+i))
+                         a5 = a(ia+i) - 0.25_wp*(a1+a2)
+                         a6 = qrt5*(a1-a2)
+                         b5 = b(ia+i) - 0.25_wp*(b1+b2)
+                         b6 = qrt5*(b1-b2)
+                         a10 = a5 + a6
+                         a20 = a5 - a6
+                         b10 = b5 + b6
+                         b20 = b5 - b6
+                         a11 = sin72*b3 + sin36*b4
+                         a21 = sin36*b3 - sin72*b4
+                         b11 = sin72*a3 + sin36*a4
+                         b21 = sin36*a3 - sin72*a4
+                         c(ja+j) = a(ia+i) + (a1+a2)
+                         c(jb+j) = a10 + a11
+                         c(je+j) = a10 - a11
+                         c(jc+j) = a20 + a21
+                         c(jd+j) = a20 - a21
+                         d(ja+j) = b(ia+i) + (b1+b2)
+                         d(jb+j) = b10 - b11
+                         d(je+j) = -(b10+b11)
+                         d(jc+j) = b20 - b21
+                         d(jd+j) = -(b20+b21)
+                         i = i + inc3
+                         j = j + inc4
+                      ENDDO
+                      ibase = ibase + inc1
+                      jbase = jbase + inc2
+                   ENDDO
+                   ibase = ibase + ijump
+                   ja = ja + jink
+                   jb = jb + jink
+                   jc = jc + jink
+                   jd = jd - jink
+                   je = je - jink
+                ENDDO
+
+                IF ( jb > jd )  RETURN
+
+             ENDIF
+
+             jbase = 0
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   a1 = a(ib+i) + a(ie+i)
+                   a3 = a(ib+i) - a(ie+i)
+                   a2 = a(ic+i) + a(id+i)
+                   a4 = a(ic+i) - a(id+i)
+                   a5 = a(ia+i) + 0.25_wp*(a3-a4)
+                   a6 = qrt5*(a3+a4)
+                   c(ja+j) = a5 + a6
+                   c(jb+j) = a5 - a6
+                   c(jc+j) = a(ia+i) - (a3-a4)
+                   d(ja+j) = -sin36*a1 - sin72*a2
+                   d(jb+j) = -sin72*a1 + sin36*a2
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ELSE
+
+             z = 1.0_wp / REAL( n, KIND=wp )
+             zqrt5  = z * qrt5
+             zsin36 = z * sin36
+             zsin72 = z * sin72
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   a1 = a(ib+i) + a(ie+i)
+                   a3 = a(ib+i) - a(ie+i)
+                   a2 = a(ic+i) + a(id+i)
+                   a4 = a(ic+i) - a(id+i)
+                   a5 = z*(a(ia+i)-0.25_wp*(a1+a2))
+                   a6 = zqrt5*(a1-a2)
+                   c(ja+j) = z*(a(ia+i)+(a1+a2))
+                   c(jb+j) = a5 + a6
+                   c(jc+j) = a5 - a6
+                   d(jb+j) = -zsin72*a3 - zsin36*a4
+                   d(jc+j) = -zsin36*a3 + zsin72*a4
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ENDIF
+
+!
+!--    Coding for factor 6
+       CASE ( 5 )
+
+          ia = 1
+          ib = ia + iink
+          ic = ib + iink
+          id = ic + iink
+          ie = id + iink
+          if = ie + iink
+          ja = 1
+          jb = ja + (2*m-la) * inc2
+          jc = jb + 2*m*inc2
+          jd = jc + 2*m*inc2
+          je = jc
+          jf = jb
+
+          IF ( la /= m )  THEN
+
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   a11 = (a(ic+i)+a(if+i)) + (a(ib+i)+a(ie+i))
+                   c(ja+j) = (a(ia+i)+a(id+i)) + a11
+                   c(jc+j) = (a(ia+i)+a(id+i)-0.5_wp*a11)
+                   d(jc+j) = sin60*((a(ic+i)+a(if+i))-(a(ib+i)+a(ie+i)))
+                   a11 = (a(ic+i)-a(if+i)) + (a(ie+i)-a(ib+i))
+                   c(jb+j) = (a(ia+i)-a(id+i)) - 0.5_wp*a11
+                   d(jb+j) = sin60*((a(ie+i)-a(ib+i))-(a(ic+i)-a(if+i)))
+                   c(jd+j) = (a(ia+i)-a(id+i)) + a11
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+             ja = ja + jink
+             jink = 2 * jink
+             jb = jb + jink
+             jc = jc + jink
+             jd = jd - jink
+             je = je - jink
+             jf = jf - jink
+             ibase = ibase + ijump
+             ijump = 2 * ijump + iink
+
+             IF ( jc /= jd )  THEN
+
+                DO  k = la, kstop, la
+                   kb = k + k
+                   kc = kb + kb
+                   kd = kc + kb
+                   ke = kd + kb
+                   kf = ke + kb
+                   c1 = trigs(kb+1)
+                   s1 = trigs(kb+2)
+                   c2 = trigs(kc+1)
+                   s2 = trigs(kc+2)
+                   c3 = trigs(kd+1)
+                   s3 = trigs(kd+2)
+                   c4 = trigs(ke+1)
+                   s4 = trigs(ke+2)
+                   c5 = trigs(kf+1)
+                   s5 = trigs(kf+2)
+                   jbase = 0
+                   DO  l = 1, la
+                      i = ibase
+                      j = jbase
+                      !DIR$ IVDEP
+                      !CDIR NODEP
+                      !OCL NOVREC
+                      DO  ijk = 1, lot
+                         a1 = c1*a(ib+i) + s1*b(ib+i)
+                         b1 = c1*b(ib+i) - s1*a(ib+i)
+                         a2 = c2*a(ic+i) + s2*b(ic+i)
+                         b2 = c2*b(ic+i) - s2*a(ic+i)
+                         a3 = c3*a(id+i) + s3*b(id+i)
+                         b3 = c3*b(id+i) - s3*a(id+i)
+                         a4 = c4*a(ie+i) + s4*b(ie+i)
+                         b4 = c4*b(ie+i) - s4*a(ie+i)
+                         a5 = c5*a(if+i) + s5*b(if+i)
+                         b5 = c5*b(if+i) - s5*a(if+i)
+                         a11 = (a2+a5) + (a1+a4)
+                         a20 = (a(ia+i)+a3) - 0.5_wp*a11
+                         a21 = sin60*((a2+a5)-(a1+a4))
+                         b11 = (b2+b5) + (b1+b4)
+                         b20 = (b(ia+i)+b3) - 0.5_wp*b11
+                         b21 = sin60*((b2+b5)-(b1+b4))
+                         c(ja+j) = (a(ia+i)+a3) + a11
+                         d(ja+j) = (b(ia+i)+b3) + b11
+                         c(jc+j) = a20 - b21
+                         d(jc+j) = a21 + b20
+                         c(je+j) = a20 + b21
+                         d(je+j) = a21 - b20
+                         a11 = (a2-a5) + (a4-a1)
+                         a20 = (a(ia+i)-a3) - 0.5_wp*a11
+                         a21 = sin60*((a4-a1)-(a2-a5))
+                         b11 = (b5-b2) - (b4-b1)
+                         b20 = (b3-b(ia+i)) - 0.5_wp*b11
+                         b21 = sin60*((b5-b2)+(b4-b1))
+                         c(jb+j) = a20 - b21
+                         d(jb+j) = a21 - b20
+                         c(jd+j) = a11 + (a(ia+i)-a3)
+                         d(jd+j) = b11 + (b3-b(ia+i))
+                         c(jf+j) = a20 + b21
+                         d(jf+j) = a21 + b20
+                         i = i + inc3
+                         j = j + inc4
+                      ENDDO
+                      ibase = ibase + inc1
+                      jbase = jbase + inc2
+                   ENDDO
+                   ibase = ibase + ijump
+                   ja = ja + jink
+                   jb = jb + jink
+                   jc = jc + jink
+                   jd = jd - jink
+                   je = je - jink
+                   jf = jf - jink
+                ENDDO
+
+                IF ( jc > jd )  RETURN
+
+             ENDIF
+
+             jbase = 0
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   c(ja+j) = (a(ia+i)+0.5_wp*(a(ic+i)-a(ie+i))) + sin60*(a(ib+i)-a(if+i))
+                   d(ja+j) = -(a(id+i)+0.5_wp*(a(ib+i)+a(if+i))) - sin60*(a(ic+i)+a(ie+i))
+                   c(jb+j) = a(ia+i) - (a(ic+i)-a(ie+i))
+                   d(jb+j) = a(id+i) - (a(ib+i)+a(if+i))
+                   c(jc+j) = (a(ia+i)+0.5_wp*(a(ic+i)-a(ie+i))) - sin60*(a(ib+i)-a(if+i))
+                   d(jc+j) = -(a(id+i)+0.5_wp*(a(ib+i)+a(if+i))) + sin60*(a(ic+i)+a(ie+i))
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ELSE
+
+             z = 1.0_wp/REAL(n,KIND=wp)
+             zsin60 = z*sin60
+             DO  l = 1, la
+                i = ibase
+                j = jbase
+                !DIR$ IVDEP
+                !CDIR NODEP
+                !OCL NOVREC
+                DO  ijk = 1, lot
+                   a11 = (a(ic+i)+a(if+i)) + (a(ib+i)+a(ie+i))
+                   c(ja+j) = z*((a(ia+i)+a(id+i))+a11)
+                   c(jc+j) = z*((a(ia+i)+a(id+i))-0.5_wp*a11)
+                   d(jc+j) = zsin60*((a(ic+i)+a(if+i))-(a(ib+i)+a(ie+i)))
+                   a11 = (a(ic+i)-a(if+i)) + (a(ie+i)-a(ib+i))
+                   c(jb+j) = z*((a(ia+i)-a(id+i))-0.5_wp*a11)
+                   d(jb+j) = zsin60*((a(ie+i)-a(ib+i))-(a(ic+i)-a(if+i)))
+                   c(jd+j) = z*((a(ia+i)-a(id+i))+a11)
+                   i = i + inc3
+                   j = j + inc4
+                ENDDO
+                ibase = ibase + inc1
+                jbase = jbase + inc2
+             ENDDO
+
+          ENDIF
+
+!
+!--    Coding for factor 8
+       CASE ( 6 )
+
+          IF ( la /= m )  THEN
+             ierr = 3
+             RETURN
+          ENDIF
+
+          ia = 1
+          ib = ia + iink
+          ic = ib + iink
+          id = ic + iink
+          ie = id + iink
+          if = ie + iink
+          ig = if + iink
+          ih = ig + iink
+          ja = 1
+          jb = ja + la * inc2
+          jc = jb + 2*m*inc2
+          jd = jc + 2*m*inc2
+          je = jd + 2*m*inc2
+          z = 1.0_wp / REAL( n, KIND=wp )
+          zsin45 = z * SQRT( 0.5_wp )
+
+          DO  l = 1, la
+             i = ibase
+             j = jbase
+
+             !DIR$ IVDEP
+             !CDIR NODEP
+             !OCL NOVREC
+             DO  ijk = 1, lot
+                c(ja+j) = z*(((a(ia+i)+a(ie+i))+(a(ic+i)+a(ig+i)))+((a(id+i)+ a(ih+i))+(a(ib+i)+a(if+i))))
+                c(je+j) = z*(((a(ia+i)+a(ie+i))+(a(ic+i)+a(ig+i)))-((a(id+i)+ a(ih+i))+(a(ib+i)+a(if+i))))
+                c(jc+j) = z*((a(ia+i)+a(ie+i))-(a(ic+i)+a(ig+i)))
+                d(jc+j) = z*((a(id+i)+a(ih+i))-(a(ib+i)+a(if+i)))
+                c(jb+j) = z*(a(ia+i)-a(ie+i)) + zsin45*((a(ih+i)-a(id+i))-(a(if+i)-a(ib+i)))
+                c(jd+j) = z*(a(ia+i)-a(ie+i)) - zsin45*((a(ih+i)-a(id+i))-(a(if+i)-a(ib+i)))
+                d(jb+j) = zsin45*((a(ih+i)-a(id+i))+(a(if+i)-a(ib+i))) + z*(a(ig+i)-a(ic+i))
+                d(jd+j) = zsin45*((a(ih+i)-a(id+i))+(a(if+i)-a(ib+i))) - z*(a(ig+i)-a(ic+i))
+                i = i + inc3
+                j = j + inc4
+             ENDDO
+             ibase = ibase + inc1
+             jbase = jbase + inc2
+          ENDDO
+
+    END SELECT
+
+ END SUBROUTINE qpassm
 
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> @todo Missing subroutine description.
+!> Same as qpassm, but for backward fft
 !------------------------------------------------------------------------------!
-  SUBROUTINE rpassm(a,b,c,d,trigs,inc1,inc2,inc3,inc4,lot,n,ifac,la,ierr)
-    ! Dimension a(n),b(n),c(n),d(n),trigs(n)
+ SUBROUTINE rpassm( a, b, c, d, trigs, inc1, inc2, inc3, inc4, lot, n, ifac, la, ierr )
 
     USE kinds
